=== core/unit_test/Makefile ===
KOKKOS_PATH = ../..

GTEST_PATH = ../../tpls/gtest

vpath %.cpp ${KOKKOS_PATH}/core/unit_test
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/default
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/serial
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/threads
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/openmp
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/openmptarget
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/hip
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/hpx
vpath %.cpp ${KOKKOS_PATH}/core/unit_test/cuda


TEST_HEADERS = $(wildcard $(KOKKOS_PATH)/core/unit_test/*.hpp)
TEST_HEADERS += $(wildcard $(KOKKOS_PATH)/core/unit_test/*/*.hpp)

default: build_all
	echo "End Build"

ifneq (,$(findstring Cuda,$(KOKKOS_DEVICES)))
  CXX = $(KOKKOS_PATH)/bin/nvcc_wrapper
else
  CXX = g++
endif

CXXFLAGS = -O3
LINK ?= $(CXX)
LDFLAGS ?=
override LDFLAGS += -lpthread

include $(KOKKOS_PATH)/Makefile.kokkos

KOKKOS_CXXFLAGS += -I$(GTEST_PATH) -I${KOKKOS_PATH}/core/unit_test -I${KOKKOS_PATH}/core/unit_test/category_files

TEST_TARGETS =
TARGETS =

KOKKOS_INTERNAL_HAS_OPTIMIZATIONS := $(call kokkos_has_string,$(KOKKOS_CXXFLAGS),O3)
ifneq ($(KOKKOS_INTERNAL_HAS_OPTIMIZATIONS), 1)
   KOKKOS_INTERNAL_HAS_OPTIMIZATIONS := $(call kokkos_has_string,$(KOKKOS_CXXFLAGS),O2)
   ifneq ($(KOKKOS_INTERNAL_HAS_OPTIMIZATIONS), 1)
      KOKKOS_INTERNAL_HAS_OPTIMIZATIONS := $(call kokkos_has_string,$(CXXFLAGS),O3)
      ifneq ($(KOKKOS_INTERNAL_HAS_OPTIMIZATIONS), 1)
         KOKKOS_INTERNAL_HAS_OPTIMIZATIONS := $(call kokkos_has_string,$(CXXFLAGS),O2)
      endif
   endif
endif
KOKKOS_INTERNAL_USE_RDYNAMIC := $(call kokkos_has_string,$(KOKKOS_CXXFLAGS),rdynamic)
ifneq ($(KOKKOS_INTERNAL_USE_RDYNAMIC), 1)
   KOKKOS_INTERNAL_USE_RDYNAMIC := $(call kokkos_has_string,$(CXXFLAGS),rdynamic)
endif

ifeq ($(KOKKOS_INTERNAL_USE_RDYNAMIC),1)
   ifneq ($(KOKKOS_INTERNAL_HAS_OPTIMIZATIONS),1)
      STACK_TRACE_TERMINATE_FILTER :=_dynamic
   else
      STACK_TRACE_TERMINATE_FILTER :=
   endif
else
   STACK_TRACE_TERMINATE_FILTER :=
endif

TESTS = AtomicOperations_int AtomicOperations_unsignedint AtomicOperations_longint AtomicOperations_unsignedlongint AtomicOperations_longlongint AtomicOperations_double AtomicOperations_float AtomicOperations_complexdouble AtomicOperations_complexfloat AtomicViews Atomics BlockSizeDeduction Concepts Complex Crs DeepCopyAlignment FunctorAnalysis Init LocalDeepCopy MDRange_a MDRange_b MDRange_c MDRange_d MDRange_e MDRange_f Other ParallelScanRangePolicy RangePolicy RangePolicyRequire Reductions Reducers_a Reducers_b Reducers_c Reducers_d Reducers_e Reductions_DeviceView SharedAlloc TeamBasic TeamReductionScan TeamScratch TeamTeamSize TeamVectorRange UniqueToken ViewAPI_a ViewAPI_b ViewAPI_c ViewAPI_d ViewAPI_e ViewCopy_a ViewCopy_b ViewCopy_c ViewLayoutStrideAssignment ViewMapping_a ViewMapping_b ViewMapping_subview ViewOfClass WorkGraph View_64bit ViewResize

tmp := $(foreach device, $(KOKKOS_DEVICELIST), \
  tmp2 := $(foreach test, $(TESTS), \
    $(if $(filter Test$(device)_$(test).cpp, $(shell ls Test$(device)_$(test).cpp 2>/dev/null)),,\
      $(shell echo "$(H)include <Test"$(device)"_Category.hpp>" > Test$(device)_$(test).cpp); \
      $(shell echo "$(H)include <Test"$(test)".hpp>" >> Test$(device)_$(test).cpp); \
     ) \
  ) \
)

GPU_SPACE_TESTS = SharedAlloc ViewAPI_a ViewAPI_b ViewAPI_c ViewAPI_d ViewAPI_e ViewCopy_a ViewCopy_b ViewCopy_c ViewMapping_a ViewMapping_b ViewMapping_subview

SUBVIEW_TESTS = SubView_a SubView_b SubView_c01 SubView_c02 SubView_c03 SubView_c04 SubView_c05 SubView_c06 SubView_c07 SubView_c08 SubView_c09 SubView_c10 SubView_c11 SubView_c12 SubView_c13

KOKKOS_SUBVIEW_DEVICELIST := $(filter-out Cuda, $(KOKKOS_DEVICELIST))

tmp := $(foreach device, $(KOKKOS_SUBVIEW_DEVICELIST), \
  tmp2 := $(foreach test, $(SUBVIEW_TESTS), \
    $(if $(filter Test$(device)_$(test).cpp, $(shell ls Test$(device)_$(test).cpp 2>/dev/null)),, \
      $(shell echo "$(H)include <Test"$(device)"_Category.hpp>" > Test$(device)_$(test).cpp); \
      $(shell echo "$(H)include <Test"$(test)".hpp>" >> Test$(device)_$(test).cpp); \
     ) \
  )\
)

ifeq ($(KOKKOS_INTERNAL_USE_CUDA), 1)
    tmp2 := $(foreach test, $(SUBVIEW_TESTS), \
      $(if $(filter TestCuda_$(test).cpp, $(shell ls TestCuda_$(test).cpp 2>/dev/null)),,\
        $(shell echo "$(H)include <TestCudaUVM_Category.hpp>" > TestCuda_$(test).cpp); \
        $(shell echo "$(H)include <Test"$(test)".hpp>" >> TestCuda_$(test).cpp); \
      )\
    )

    GPU_SPACES = CudaHostPinned CudaUVM
    tmp := $(foreach space, $(GPU_SPACES), \
      tmp2 := $(foreach test, $(GPU_SPACE_TESTS), \
        $(if $(filter Test$(space)_$(test).cpp, $(shell ls Test$(space)_$(test).cpp 2>/dev/null)),,\
          $(shell echo "$(H)include <Test$(space)_Category.hpp>" > Test$(space)_$(test).cpp); \
          $(shell echo "$(H)include <Test"$(test)".hpp>" >> Test$(space)_$(test).cpp); \
        )\
      )\
    )

    OBJ_CUDA = UnitTestMainInit.o gtest-all.o
    OBJ_CUDA += TestCuda_Init.o
    OBJ_CUDA += TestCuda_SharedAlloc.o TestCudaUVM_SharedAlloc.o TestCudaHostPinned_SharedAlloc.o
    OBJ_CUDA += TestCuda_RangePolicy.o TestCuda_RangePolicyRequire.o
    OBJ_CUDA += TestCuda_ViewAPI_a.o TestCuda_ViewAPI_b.o TestCuda_ViewAPI_c.o TestCuda_ViewAPI_d.o TestCuda_ViewAPI_e.o TestCuda_ViewCopy_a.o TestCuda_ViewCopy_b.o TestCuda_ViewCopy_c.o
    OBJ_CUDA += TestCuda_DeepCopyAlignment.o
    OBJ_CUDA += TestCuda_ViewMapping_a.o TestCuda_ViewMapping_b.o TestCuda_ViewMapping_subview.o TestCuda_ViewResize.o TestCuda_ViewLayoutStrideAssignment.o
    OBJ_CUDA += TestCudaUVM_ViewAPI_a.o TestCudaUVM_ViewAPI_b.o TestCudaUVM_ViewAPI_c.o TestCudaUVM_ViewAPI_d.o TestCudaUVM_ViewAPI_e.o
    OBJ_CUDA += TestCudaUVM_ViewCopy_a.o TestCudaUVM_ViewCopy_b.o TestCudaUVM_ViewCopy_c.o
    OBJ_CUDA += TestCudaUVM_ViewMapping_a.o TestCudaUVM_ViewMapping_b.o TestCudaUVM_ViewMapping_subview.o
    OBJ_CUDA += TestCudaHostPinned_ViewAPI_a.o TestCudaHostPinned_ViewAPI_b.o TestCudaHostPinned_ViewAPI_c.o TestCudaHostPinned_ViewAPI_d.o TestCudaHostPinned_ViewAPI_e.o
    OBJ_CUDA += TestCudaHostPinned_ViewCopy_a.o TestCudaHostPinned_ViewCopy_b.o TestCudaHostPinned_ViewCopy_c.o
    OBJ_CUDA += TestCudaHostPinned_ViewMapping_a.o TestCudaHostPinned_ViewMapping_b.o TestCudaHostPinned_ViewMapping_subview.o
    OBJ_CUDA += TestCuda_View_64bit.o
    OBJ_CUDA += TestCuda_ViewOfClass.o
    OBJ_CUDA += TestCuda_SubView_a.o TestCuda_SubView_b.o
    OBJ_CUDA += TestCuda_SubView_c01.o TestCuda_SubView_c02.o TestCuda_SubView_c03.o
    OBJ_CUDA += TestCuda_SubView_c04.o TestCuda_SubView_c05.o TestCuda_SubView_c06.o
    OBJ_CUDA += TestCuda_SubView_c07.o TestCuda_SubView_c08.o TestCuda_SubView_c09.o
    OBJ_CUDA += TestCuda_SubView_c10.o TestCuda_SubView_c11.o TestCuda_SubView_c12.o
    OBJ_CUDA += TestCuda_SubView_c13.o
    OBJ_CUDA += TestCuda_Reductions.o TestCuda_ParallelScanRangePolicy.o
    OBJ_CUDA += TestCuda_Reductions_DeviceView.o
    OBJ_CUDA += TestCuda_Reducers_a.o TestCuda_Reducers_b.o TestCuda_Reducers_c.o TestCuda_Reducers_d.o TestCuda_Reducers_e.o
    OBJ_CUDA += TestCuda_Complex.o
    OBJ_CUDA += TestCuda_AtomicOperations_int.o TestCuda_AtomicOperations_unsignedint.o TestCuda_AtomicOperations_longint.o
    OBJ_CUDA += TestCuda_AtomicOperations_unsignedlongint.o TestCuda_AtomicOperations_longlongint.o TestCuda_AtomicOperations_double.o TestCuda_AtomicOperations_float.o
    OBJ_CUDA += TestCuda_AtomicOperations_complexfloat.o TestCuda_AtomicOperations_complexdouble.o
    OBJ_CUDA += TestCuda_AtomicViews.o TestCuda_Atomics.o
    OBJ_CUDA += TestCuda_TeamBasic.o TestCuda_TeamScratch.o
    OBJ_CUDA += TestCuda_TeamReductionScan.o TestCuda_TeamTeamSize.o
    OBJ_CUDA += TestCuda_TeamVectorRange.o
    OBJ_CUDA += TestCuda_Other.o
    OBJ_CUDA += TestCuda_MDRange_a.o TestCuda_MDRange_b.o TestCuda_MDRange_c.o TestCuda_MDRange_d.o TestCuda_MDRange_e.o
    OBJ_CUDA += TestCuda_Crs.o
    ifneq ($(KOKKOS_INTERNAL_DISABLE_DEPRECATED_CODE), 1)
      OBJ_CUDA += TestCuda_Task.o
    endif
    OBJ_CUDA += TestCuda_WorkGraph.o
    OBJ_CUDA += TestCuda_Spaces.o
    OBJ_CUDA += TestCuda_UniqueToken.o
    OBJ_CUDA += TestCuda_LocalDeepCopy.o
    OBJ_CUDA += TestCuda_DebugSerialExecution.o
    OBJ_CUDA += TestCuda_DebugPinUVMSpace.o
    OBJ_CUDA += TestCuda_TeamScratchStreams.o

    TARGETS += KokkosCore_UnitTest_Cuda
    TARGETS += KokkosCore_UnitTest_CudaInterOpInit
    TARGETS += KokkosCore_UnitTest_CudaInterOpStreams
    TEST_TARGETS += test-cuda
endif

ifeq ($(KOKKOS_INTERNAL_USE_THREADS), 1)
    OBJ_THREADS = UnitTestMainInit.o gtest-all.o
    OBJ_THREADS += TestThreads_Init.o
    OBJ_THREADS += TestThreads_SharedAlloc.o
    OBJ_THREADS += TestThreads_RangePolicy.o TestThreads_RangePolicyRequire.o
    OBJ_THREADS += TestThreads_View_64bit.o
    OBJ_THREADS += TestThreads_ViewAPI_a.o TestThreads_ViewAPI_b.o TestThreads_ViewAPI_c.o TestThreads_ViewAPI_d.o TestThreads_ViewAPI_e.o
    OBJ_THREADS += TestThreads_ViewCopy_a.o TestThreads_ViewCopy_b.o TestThreads_ViewCopy_c.o
    OBJ_THREADS += TestThreads_DeepCopyAlignment.o
    OBJ_THREADS += TestThreads_ViewMapping_a.o TestThreads_ViewMapping_b.o TestThreads_ViewMapping_subview.o TestThreads_ViewResize.o TestThreads_ViewLayoutStrideAssignment.o
    OBJ_THREADS += TestThreads_ViewOfClass.o
    OBJ_THREADS += TestThreads_SubView_a.o TestThreads_SubView_b.o
    OBJ_THREADS += TestThreads_SubView_c01.o TestThreads_SubView_c02.o TestThreads_SubView_c03.o
    OBJ_THREADS += TestThreads_SubView_c04.o TestThreads_SubView_c05.o TestThreads_SubView_c06.o
    OBJ_THREADS += TestThreads_SubView_c07.o TestThreads_SubView_c08.o TestThreads_SubView_c09.o
    OBJ_THREADS += TestThreads_SubView_c10.o TestThreads_SubView_c11.o TestThreads_SubView_c12.o
    OBJ_THREADS += TestThreads_Reductions.o TestThreads_ParallelScanRangePolicy.o
    OBJ_THREADS += TestThreads_Reductions_DeviceView.o
    OBJ_THREADS += TestThreads_Reducers_a.o TestThreads_Reducers_b.o TestThreads_Reducers_c.o TestThreads_Reducers_d.o TestThreads_Reducers_e.o
    OBJ_THREADS += TestThreads_Complex.o
    OBJ_THREADS += TestThreads_AtomicOperations_int.o TestThreads_AtomicOperations_unsignedint.o TestThreads_AtomicOperations_longint.o
    OBJ_THREADS += TestThreads_AtomicOperations_unsignedlongint.o TestThreads_AtomicOperations_longlongint.o TestThreads_AtomicOperations_double.o TestThreads_AtomicOperations_float.o
    OBJ_THREADS += TestThreads_AtomicOperations_complexfloat.o TestThreads_AtomicOperations_complexdouble.o
    OBJ_THREADS += TestThreads_AtomicViews.o TestThreads_Atomics.o
    OBJ_THREADS += TestThreads_TeamBasic.o TestThreads_TeamScratch.o TestThreads_TeamTeamSize.o
    OBJ_THREADS += TestThreads_TeamReductionScan.o
    OBJ_THREADS += TestThreads_TeamVectorRange.o
    OBJ_THREADS += TestThreads_Other.o
    OBJ_THREADS += TestThreads_MDRange_a.o TestThreads_MDRange_b.o TestThreads_MDRange_c.o TestThreads_MDRange_d.o TestThreads_MDRange_e.o
    OBJ_THREADS += TestThreads_LocalDeepCopy.o

    TARGETS += KokkosCore_UnitTest_Threads

    TEST_TARGETS += test-threads
endif

ifeq ($(KOKKOS_INTERNAL_USE_OPENMP), 1)
    OBJ_OPENMP = UnitTestMainInit.o gtest-all.o
    OBJ_OPENMP += TestOpenMP_Init.o
    OBJ_OPENMP += TestOpenMP_SharedAlloc.o
    OBJ_OPENMP += TestOpenMP_RangePolicy.o TestOpenMP_RangePolicyRequire.o
    OBJ_OPENMP += TestOpenMP_View_64bit.o
    OBJ_OPENMP += TestOpenMP_ViewAPI_a.o TestOpenMP_ViewAPI_b.o TestOpenMP_ViewAPI_c.o TestOpenMP_ViewAPI_d.o TestOpenMP_ViewAPI_e.o
    OBJ_OPENMP += TestOpenMP_DeepCopyAlignment.o TestOpenMP_ViewCopy_a.o TestOpenMP_ViewCopy_b.o TestOpenMP_ViewCopy_c.o
    OBJ_OPENMP += TestOpenMP_ViewMapping_a.o TestOpenMP_ViewMapping_b.o TestOpenMP_ViewMapping_subview.o TestOpenMP_ViewResize.o TestOpenMP_ViewLayoutStrideAssignment.o
    OBJ_OPENMP += TestOpenMP_ViewOfClass.o
    OBJ_OPENMP += TestOpenMP_SubView_a.o TestOpenMP_SubView_b.o
    OBJ_OPENMP += TestOpenMP_SubView_c01.o TestOpenMP_SubView_c02.o TestOpenMP_SubView_c03.o
