=== debian/changelog ===
kokkos (4.5.01-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove unnecessary build dependencies (Closes: #1100593)
  * Remove deprecated compile options and enable tests

 -- Nils Schild <nils.schild@posteo.de>  Tue, 25 Mar 2025 22:09:46 +0100

kokkos (4.5.01-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.1.
  * d/copyright: bump years.
  * d/control:
    - adapted for new version.
    - exclude libmemkind-dev on s390x.

 -- Alex Myczko <tar@debian.org>  Tue, 04 Mar 2025 08:28:58 +0000
