=== debian/control ===
Source: kokkos
Section: science
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 python3,
Standards-Version: 4.7.1
Homepage: https://github.com/kokkos/kokkos
Vcs-Browser: https://salsa.debian.org/debian/kokkos
Vcs-Git: https://salsa.debian.org/debian/kokkos.git
Rules-Requires-Root: no

Package: kokkos
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Performance Portability Programming
 This implements a programming model in C++ for writing performance
 portable applications targeting all major HPC platforms. For that purpose it
 provides abstractions for both parallel execution of code and data management.
 Kokkos is designed to target complex node architectures with N-level memory
 hierarchies and multiple types of execution resources. It currently can use
 CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
 backends in development.

Package: libkokkos4.5
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ Performance Portability Programming
 This implements a programming model in C++ for writing performance
 portable applications targeting all major HPC platforms. For that purpose it
 provides abstractions for both parallel execution of code and data management.
 Kokkos is designed to target complex node architectures with N-level memory
 hierarchies and multiple types of execution resources. It currently can use
 CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
 backends in development.

Package: libkokkos-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libkokkos4.5 (= ${binary:Version}),
Description: C++ Performance Portability Programming
 This implements a programming model in C++ for writing performance
 portable applications targeting all major HPC platforms. For that purpose it
 provides abstractions for both parallel execution of code and data management.
 Kokkos is designed to target complex node architectures with N-level memory
 hierarchies and multiple types of execution resources. It currently can use
 CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
 backends in development.
 .
 This is a development package of kokkos.
