=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DKokkos_ENABLE_OPENMP=ON \
	-DKokkos_ENABLE_TESTS=ON

# Tests use all CPUs and would run into time outs when blocked
override_dh_auto_test:
	dh_auto_test --no-parallel
